(function() {
    // 计算时间差
    function timeDiff(time){
        var diffdate = new Date().getTime() - time*1000;
        var days = Math.floor(diffdate/(24*3600*1000));
        var leave1 = diffdate%(24*3600*1000);   
        var hours = Math.floor(leave1/(3600*1000));  

        var leave2 = leave1%(3600*1000);
        var minutes = Math.floor(leave2/(60*1000));
        var leave3 = leave2%(60*1000);
        var seconds = Math.round(leave3/1000);
        return (days && days > 0) ? days + "天前" : (hours && hours > 0) ? hours + "小时前" : (minutes && minutes > 0) ? minutes + "分钟前" : "刚刚";
    }

    /*点击头像后，前往作者详情*/
    function openAuthor(authorId) {
        //TODO 实现native交互，跳转作者的界面
        if (window.newsArticle) {
                    window.newsArticle.openAuthor(authorId)
                } else {
                    console.log("openAuthor: " + authorId);
                }
    }
    
    /*
     * 喜欢文章
     * */
    function likeArticle(aid,callback) {
        //TODO 实现native交互，喜欢文章，返回结果（Boolean）给h5前端
        console.log(aid);
         if (window.newsArticle) {
                    var func = $mob.ext._bindCallbackFunc(callback)
                    window.newsArticle.likeArticle(aid, func)
                } else {
                    callback(true)
                }
    }
	
    /*打开图片*/
    function openImage(imgList,index) {
        //TODO 实现native交互，跳转打开图片的界面
        if (window.newsArticle) {
                           window.newsArticle.openImage(imgList, index);
                       } else {
                           console.log(index)
                           console.log(JSON.stringify(imgList, null,2))
                           var map = {
                               imageUrls: imgList,
                               index: index
                           };
                           prompt("openImage", JSON.stringify(map));
                       }
    }

    /*打开附件*/
    function openAttachment(attachment) {
        //TODO 实现native交互，跳转打开附件的界面
       console.log(attachment);
               if (window.newsArticle) {
                   window.newsArticle.openAttachment(JSON.stringify(attachment));
               } else {
                   console.log(attachment);
                   prompt("openAttachment", JSON.stringify(attachment));
               }
    }

    /* 跳转链接 */
    function openHref(href) {
    	//TODO 实现native交互，跳转到链接：href
       if (window.newsArticle) {
                    window.newsArticle.openHref(href);
                } else {
                    var map = {
                        clickUrl: href,
                    };
                    prompt("openHref", JSON.stringify(map));
                }
    }
    function openRelatedArticle(aid){
        if (window.newsArticle) {
                    window.newsArticle.openRelatedArticle(aid);
                } else {
                    console.log(aid);
                }
    }
    /* 下载图片，iimgList为界面所有的img标签对应的图片链接 */
    function downloadImages(imgUrls) {
        //TODO 由Native去实现下载图片，并通过showImage方法，将下载好的图片返回给h5进行显示
        if (window.newsArticle) {
            window.newsArticle.downloadImages(imgUrls);
        } else if (window.forumImage) {
            window.forumImage.downloadImages(imgUrls);
        } else {
            var map = {
                imageUrls: imgUrls,
            };
            prompt("downloadImages", JSON.stringify(map));
        }
    }
    
//    /* 显示图片，替换imgUrl对应的img标签的src值为imgSrc，其中imgSrc为Native已经下载好的本地图片地址 */
//    function showImage(imgUrlMD5, imgSrc) {
//        //H5实现此方法，并进行图片替换操作
//    	if (imgSrc) {
//    		$("."+imgUrlMD5).attr("src",imgSrc)
//			$("."+imgUrlMD5).attr("src_flag",'1')
//    	} else{
//    		$("."+imgUrlMD5).attr("src",'../assets/images/default_pic_error.png')
//    	}
//    }
 function showImage(index, imgUrlMD5, imgSrc, isImageViewer) {
    if (isImageViewer) {
        if (imgSrc) {
            $(".photo-browser .photo-browser-swiper-container .swiper-slide").eq(index).find("img").attr("src", imgSrc);
        } else {
            $(".photo-browser .photo-browser-swiper-container .swiper-slide").eq(index).find("img").attr("src", "img/default_pic_error.png");
        }
    } else {
       if (imgSrc) {
            $("."+imgUrlMD5).attr("src",imgSrc)
            $("."+imgUrlMD5).attr("src_flag",'1')
       } else{
            $("."+imgUrlMD5).attr("src",'../assets/images/default_pic_error.png')
       }
    }
    }

    /* 获取图片集合地址和当前索引 
    * 设置hideNav为true时不显示头
    */
    function getImageUrlsAndIndex(callback,hideNav) {
        //TODO 由Native返回对象{imageUrls:[], index:0}
        var data = null;
                        if (window.forumImage) {
                            data = JSON.parse(window.forumImage.getImageUrlsAndIndex());
                        } else {
                            data = JSON.parse(prompt("getImageUrlsAndIndex"));
                        }
                        callback(data);
                        if (hideNav) {
                            $(".photo-browser .bar").hide();
                            $(".bar-nav~.content").css({"top": "0"});
                        }
    }
    
    /**
     * press 回调
     * @param  {[type]} img [description]
     * @return {[type]}     [description]
     */
    function pressImgCallback(img){
        console.log(img);
    }


    /*设置当前页面图片地址和index*/
    function setCurrentImageSrc(imgSrc, index) {
        //TODO 由Native去实现图片界面切换后的界面状态
        if (window.forumImage) {
                            window.forumImage.setCurrentImageSrc(imgSrc, index);
                        } else {
                            var map = {
                                imageSrc: imgSrc,
                                index: index
                            };
                            prompt("setCurrentImageSrc", JSON.stringify(map));
                        }
    }

    /*获取门户文章详情*/
    function getNewsArticleDetails (callback) {
        //TODO 实现native交互，获取主题帖子详情数据，并传给H5前端,由H5前端转换成 JSON.parse();
        var data = null;
            try {
                if (window.newsArticle) {
                    data = window.newsArticle.getNewsArticleDetails();
                } else {
                    data = prompt("getNewsArticleDetails");
                }
            } catch(err) {
            }
        callback(data);
    }
    /*
     * 获取文章回帖列表
     * */
    function getComments(aid, page,pageSize,callback) {
        try {
            if (window.newsArticle) {
                var func = $mob.ext._bindCallbackFunc(callback)
                window.newsArticle.getComments(aid, page,pageSize,func);
            } else {
                var map = {
                    aid: aid,
                    page: page,
                    pageSize: pageSize,
                    callback: func
                };
                prompt("getComments", JSON.stringify(map));
            }
        } catch(err) {
            console.log(err)
            callback(null);
        }
    }

    function addNewCommentHtml(data){
            console.log(data);
        // 实现native交互，添加新的评论
         if(window.newsArticle) {
            details.article.commentnum++
            details.commentList.unshift(data)//将data插入即可
        } else {
            console.log(data);
        }
    }

    /*界面跳转到评论模块*/
    function goComment() {
        details.goComment()
    }

    function showAddress(data) {
        if (window.newsArticle) {
            window.newsArticle.showAddress(JSON.stringify(data))
        } else {
            console.log("show address data : " + JSON.stringify(data))
        }
    }
    /*定义BBSSDKNative全局属性*/
    window.BBSSDKNative = {
        openImage: openImage,
        openAttachment: openAttachment,
        openHref: openHref,
        getImageUrlsAndIndex: getImageUrlsAndIndex,
        setCurrentImageSrc: setCurrentImageSrc,
        downloadImages: downloadImages,
        showImage: showImage,
        pressImgCallback: pressImgCallback,
        openAuthor:openAuthor,
        likeArticle:likeArticle,
        goComment:goComment,

        getNewsArticleDetails :getNewsArticleDetails,
        getComments:getComments,
        openRelatedArticle:openRelatedArticle,
        addNewCommentHtml:addNewCommentHtml,
        showAddress:showAddress
    }
})();